using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CallCenterApi.DB;
using System.Data;
using System.Data.SqlClient;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_SystemConfig
    /// </summary>
    public partial class T_Sys_SystemConfig
    {
        public T_Sys_SystemConfig()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ParamId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_SystemConfig");
            strSql.Append(" where F_ParamId=@F_ParamId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ParamId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_SystemConfig model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_SystemConfig(");
            strSql.Append("F_ParamCode,F_ParamValue,F_ParamDes,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_ParamCode,@F_ParamValue,@F_ParamDes,@F_State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ParamValue", SqlDbType.VarChar,100),
                    new SqlParameter("@F_ParamDes", SqlDbType.VarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4)};
            parameters[0].Value = model.F_ParamCode;
            parameters[1].Value = model.F_ParamValue;
            parameters[2].Value = model.F_ParamDes;
            parameters[3].Value = model.F_State;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_SystemConfig model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_SystemConfig set ");
            strSql.Append("F_ParamCode=@F_ParamCode,");
            strSql.Append("F_ParamValue=@F_ParamValue,");
            strSql.Append("F_ParamDes=@F_ParamDes,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_ParamId=@F_ParamId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ParamValue", SqlDbType.VarChar,100),
                    new SqlParameter("@F_ParamDes", SqlDbType.VarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_ParamId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_ParamCode;
            parameters[1].Value = model.F_ParamValue;
            parameters[2].Value = model.F_ParamDes;
            parameters[3].Value = model.F_State;
            parameters[4].Value = model.F_ParamId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ParamId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SystemConfig ");
            strSql.Append(" where F_ParamId=@F_ParamId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ParamId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_ParamIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SystemConfig ");
            strSql.Append(" where F_ParamId in (" + F_ParamIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_SystemConfig GetModel(int F_ParamId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ParamId,F_ParamCode,F_ParamValue,F_ParamDes,F_State from T_Sys_SystemConfig ");
            strSql.Append(" where F_ParamId=@F_ParamId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ParamId;

            Model.T_Sys_SystemConfig model = new Model.T_Sys_SystemConfig();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_SystemConfig DataRowToModel(DataRow row)
        {
            Model.T_Sys_SystemConfig model = new Model.T_Sys_SystemConfig();
            if (row != null)
            {
                if (row["F_ParamId"] != null && row["F_ParamId"].ToString() != "")
                {
                    model.F_ParamId = int.Parse(row["F_ParamId"].ToString());
                }
                if (row["F_ParamCode"] != null)
                {
                    model.F_ParamCode = row["F_ParamCode"].ToString();
                }
                if (row["F_ParamValue"] != null)
                {
                    model.F_ParamValue = row["F_ParamValue"].ToString();
                }
                if (row["F_ParamDes"] != null)
                {
                    model.F_ParamDes = row["F_ParamDes"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ParamId,F_ParamCode,F_ParamValue,F_ParamDes,F_State ");
            strSql.Append(" FROM T_Sys_SystemConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ParamId,F_ParamCode,F_ParamValue,F_ParamDes,F_State ");
            strSql.Append(" FROM T_Sys_SystemConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_SystemConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ParamId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_SystemConfig T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }



        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod

        /// <summary>
        /// 根据编号获取值
        /// </summary>
        /// <param name="p_ParamCode">编号</param>
        /// <returns></returns>
        public string GetParamValueByParamCode(string p_ParamCode)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ParamValue from T_Sys_SystemConfig ");
            strSql.Append(" where F_ParamCode=@F_ParamCode");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ParamCode", SqlDbType.VarChar,50)
};
            parameters[0].Value = p_ParamCode;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);

            if (obj == null)
            {
                return "";
            }
            else
            {
                return obj.ToString();
            }

        }
    }
}
